$(document).ready(function () {

    var address_input_name = '';
    var address_xhr;

    if (document.getElementsByName("address").length == 1)
        address_input_name = 'address';
    else
        if (document.getElementsByName("address1").length == 1)
            address_input_name = 'address1';
    else
        address_input_name = 'address2';

    var address_field = $( "input[name='"+address_input_name+"']" );


	if (typeof elp_postapi_integration_promo_text !== 'undefined') {
	    $('.postapi_txt').remove();
        $("input[name*='postcode']").after(elp_postapi_integration_promo_text);
    }

    if(
        address_field.length === 1 &&
        typeof address_field.autocomplete === 'function' &&
        typeof elp_postapi_integration_autocomplete !== 'undefined' &&
        elp_postapi_integration_autocomplete == 1
    )
    {
        var request_args = [];

        if (typeof elp_postapi_integration_key !== 'undefined')
            request_args['key'] = elp_postapi_integration_key;
        else
        if (typeof elp_postapi_integration_token !== 'undefined')
            request_args['token'] = elp_postapi_integration_token;
        else
            request_args['key'] = '';


        address_field.autocomplete({
            minLength: 4,
            delay: 400,
            source: function(request, response)
            {
                // if not lithuania - skip
                if (
                    typeof elp_postapi_integration_lt_country_id !== 'undefined' &&
                    $("[name=id_country]").first().val() != elp_postapi_integration_lt_country_id
                ) {
                    return;
                }

                request_args = {
                    token: request_args['token'],
                    key: request_args['key'],
                    autocomplete: 1,
                    wide_number: 0,
                };

                var request_data = $.extend(request_args, {address: $.trim(request.term)});


                if(address_xhr)
                {
                    address_xhr.abort();
                }

                address_xhr = $.ajax({
                    url: elp_postapi_integration_url,
                    dataType: 'json',
                    crossDomain: true,
                    data: request_data,
                    success: function(resp)
                    {
                        var r = [];
                        if (!resp.success)
                        {
                            response(r);
                            return;
                        }

                        for(var i = 0, l = resp.data.length; i < l; i++)
                        {
                            var t = '';
                            var address = resp.data[i].address;

                            if (address === '')
                            {
                                t = (resp.data[i].city);
                            }
                            else
                            {
                                if(typeof resp.address_apartment != "undefined")
                                {
                                    address += '-'+resp.address_apartment;
                                }

                                t = (address + ', ' + resp.data[i].city);
                            }

                            r.push({
                                label: t + ', ' + resp.data[i].postcode,
                                value: address,
                                address: address,
                                city: resp.data[i].city,
                                postcode: resp.data[i].postcode
                            });
                            response(r);
                        }

                    },
                    error: function(){
                        response([]);
                    },
                    complete: function(){

                    }
                });
            },
            select: function(event, ui){
                $("input[name='postcode']").val(ui.item.postcode);
                $("input[name='city']").val(ui.item.city);
                $(address_field).val(ui.item.address);
                $( "input[name='postcode']" ).trigger('change'); // change for validation
                $( "input[name='city']" ).trigger('change'); // change for validation

            }
        });

        address_field.attr('autocomplete', 'nofill');
    }
    else
    {
        $(document).on( "blur", "input[name='"+address_input_name+"']", function(){ searchPostCode(); } );
        $(document).on( "blur", "input[name='city']", function(){ searchPostCode(); } );
    }


    function searchPostCode()
    {
        if (
			typeof elp_postapi_integration_lt_country_id !== 'undefined' &&
			$("[name=id_country]").first().val() != elp_postapi_integration_lt_country_id
		) {
			return;
		}

        var address = $( "input[name='"+address_input_name+"']" ).val();
        var city = $( "input[name='city']" ).val();

		var request_data = {address: address, city: city};

		if (typeof elp_postapi_integration_key !== 'undefined')
			request_data['key'] = elp_postapi_integration_key;
		else
			if (typeof elp_postapi_integration_token !== 'undefined')
				request_data['token'] = elp_postapi_integration_token;
			else
				request_data['key'] = '';


        if (address.length > 0 && city.length > 0)
        {
            $.ajax({
				method: "POST",
                url: (typeof elp_postapi_integration_url !== 'undefined' ? elp_postapi_integration_url : ''),
                dataType: 'json',
				data: request_data,
				crossDomain: true,
				timeout: 10000,
                success: function(data) {

                    if (data.success == true && data.total_found == 1)
                    {
                        $( "input[name='postcode']" ).val(data.data[0].postcode);
                        $( "input[name='postcode']" ).trigger('change');
                    }
                }
            });
            return;
        }
    }

});
